--- chan_sip.c.old	2008-10-02 08:14:59.000000000 +0200
+++ chan_sip.c.contact	2008-10-02 10:25:19.433698984 +0200
@@ -5954,7 +5954,20 @@
 			snprintf(contact, sizeof(contact), "%s;expires=%d", p->our_contact, p->expiry);
 			add_header(resp, "Contact", contact);	/* Not when we unregister */
 		}
-	} else if (msg[0] != '4' && !ast_strlen_zero(p->our_contact)) {
+	} else if ((((msg[0] == '1') && ((p->method == SIP_INVITE) || (p->method == SIP_SUBSCRIBE) || (p->method == SIP_NOTIFY) || (p->method == SIP_UPDATE))) ||
+		    ((msg[0] == '2') && ((p->method == SIP_INVITE) || (p->method == SIP_OPTIONS) || (p->method == SIP_REFER) || (p->method == SIP_SUBSCRIBE) || (p->method == SIP_NOTIFY) || (p->method == SIP_UPDATE))) ||
+		    ((msg[0] == '3') && (p->method != SIP_CANCEL) && (p->method != SIP_INFO)) ||
+		    ((msg[0] == '4') && (msg[1] == '8') && (msg[2] == '5') && (p->method != SIP_CANCEL) && (p->method != SIP_INFO))) &&
+		    !ast_strlen_zero(p->our_contact)) {
+		/* HJ: compliance for Contact header in responses checked from:
+		 * - RFC 2976 (INFO)
+		 * - RFC 3261 (ACK, BYE, CANCEL, INVITE, OPTIONS, REGISTER
+		 * - RFC 3262 (PRACK)
+		 * - RFC 3265 (SUBSCRIBE, NOTIFY)
+		 * - RFC 3311 (UPDATE)
+		 * - RFC 3428 (MESSAGE)
+		 * - RFC 3515 (REFER)
+		 * - RFC 3903 (PUBLISH) */
 		add_header(resp, "Contact", p->our_contact);
 	}
 	return 0;
